/*!
 *
 * Copyright 2017 - acrazing
 *
 * @author acrazing joking.young@gmail.com
 * @since 2017-11-28 17:31:44
 * @version 1.0.0
 * @desc sync.ts
 */
import { IReactionDisposer } from 'mobx';
export interface SyncStorage {
    getItem(key: string): string | null;
    setItem(key: string, value: string): void;
    removeItem(key: string): void;
}
/**
 * sync trunk initial options
 */
export interface SyncTrunkOptions {
    /**
     * storage, SyncStorage only
     * default is localStorage
     */
    storage?: SyncStorage;
    /**
     * the storage key, default is KeyDefaultKey
     */
    storageKey?: string;
    /**
     * the delay time, default is 0
     */
    delay?: number;
}
export declare class SyncTrunk {
    disposer: IReactionDisposer;
    private store;
    private storage;
    private storageKey;
    private delay;
    constructor(store: any, { storage, storageKey, delay }?: SyncTrunkOptions);
    persist(): void;
    /**
     * init the store
     */
    init(initialStore?: any): void;
    clear(): void;
    updateStore(store: any): void;
}
//# sourceMappingURL=sync.d.ts.map